// 002 u_c_cgi_html_base_page_builder
// 29 apr 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_cgi_html_base_page_builder;
  interface
    uses Classes
      , u_c_cgi_basic_object
      , u_c_cgi_log
      ;

    type c_html_base_page_builder= class(c_basic_object)
                                     // -- m_name: the request (for the error display)
                                     m_c_simple_log_ref: c_simple_log;
                                     m_c_html_page: tStringList;
                                     m_site_url: String;

                                     m_title: String;
                                     m_c_meta_list: tStringList;

                                     m_write_log_debug_search: Boolean;

                                     _m_current_line: String;

                                     Constructor create_html_base_page_builder(p_name: String;
                                         p_site_url: String); // Virtual;

                                     procedure write_log_debug_search(p_text: String);

                                     procedure add_meta_line(p_meta_line: String);

                                       procedure build_string(p_text: String);
                                       procedure build_line(p_text: String);
                                       procedure build_page_start;
                                       procedure build_page_end;
                                     procedure build_empty_answer;

                                     Destructor Destroy; Override;
                                   end; // c_html_base_page_builder

  implementation
    uses SysUtils
      , u_cgi_strings // f_replace_character
      , u_cgi_strings_html // f_nbsp
      , u_cgi_helpers
      , u_cgi_html_generation_helpers
      ;

    // -- c_html_base_page_builder

    Constructor c_html_base_page_builder.create_html_base_page_builder(p_name: String;
        p_site_url: String);
      begin
        Inherited create_basic_object(p_name);

        m_site_url:= p_site_url;
        m_c_html_page:= tStringList.Create;
        m_c_meta_list:= tStringList.Create;

        write_log('  ok create_basic_result');
      end; // create_html_base_page_builder

    procedure c_html_base_page_builder.write_log_debug_search(p_text: String);
      begin
        if m_write_log_debug_search
          then write_log(p_text);
      end; // write_to_log

    procedure c_html_base_page_builder.add_meta_line(p_meta_line: String);
      begin
        m_c_meta_list.Add(p_meta_line);
      end; // add_meta_line

    procedure c_html_base_page_builder.build_string(p_text: String);
      begin
        _m_current_line:= _m_current_line+ p_text;
      end; // build_string

    procedure c_html_base_page_builder.build_line(p_text: String);
      begin
        m_c_html_page.Add(_m_current_line+ p_text);
        _m_current_line:= '';
      end; // build_line

    procedure c_html_base_page_builder.build_page_start;
      var l_meta_index: Integer;
      begin
        with m_c_html_page do
        begin
          Add('<HTML>');
          Add('  <HEAD>');

          if m_title<> ''
            then begin
                Add('    <TITLE>'+ m_title+ '</TITLE>');
                with m_c_meta_list do
                  for l_meta_index:= 0 to Count- 1 do
                    Add('    '+ Strings[l_meta_index]);
              end;
          Add('  </HEAD>');
          Add('  <BODY>');
        end; // build_head_title_body
      end; // build_page_start

    procedure c_html_base_page_builder.build_page_end;
      begin
        with m_c_html_page do
        begin
          Add('  </BODY>');
          Add('</HTML>');
        end; // build_head_title_body
      end; // build_page_end

    procedure c_html_base_page_builder.build_empty_answer;
      begin
        build_page_start;
        with m_c_html_page do
        begin
          Add('      No answer');
        end; // with m_c_html_page
        build_page_end;
      end; // build_empty_answer

    Destructor c_html_base_page_builder.Destroy;
      begin
        m_c_html_page.Free;
        m_c_meta_list.Free;

        Inherited;
      end; // Destroy

    begin // u_c_html_base_page_builder
    end. // u_c_html_base_page_builder


