// 003 u_cgi_database_handler
// 22 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_cgi_database_handler;
  Interface

    procedure do_handle_cgi(p_write_segment,
        p_log_name, p_site_url: String);

    const // -- default to get string to system
          k_output= '';
    var // -- will be filled by the caller in debug mode
        g_output_name: String= k_output;
        g_debug_request: String= '';

  Implementation
    uses Classes, SysUtils
        , Db, DbTables
        , u_c_cgi_log, u_cgi_strings
        , u_cgi_helpers
        , u_cgi_environment
        , u_c_cgi_base_forms

        , u_c_cgi_html_base_page_builder
        ;

    const k_content_type= 'Content-type: text/html';

    procedure do_handle_cgi(p_write_segment,
        p_log_name, p_site_url: String);

      function f_is_debug: Boolean;
        begin
          Result:= g_output_name<> k_output;
        end; // f_is_debug

      procedure log_enviroment;
        begin
          write_log('|'+ f_get_all_environment_string+ '|');
        end; // log_environment

      procedure analyze_form_values(var pv_c_key_value_list: tStringList);
        var l_raw_request_string: String;
        begin
          if f_is_debug
            then extract_key_values(g_debug_request, pv_c_key_value_list)
            else
              with c_base_form.create_base_form('forms') do
              begin
                get_form_result;

                l_raw_request_string:= m_raw_answer_string;

                pv_c_key_value_list:= tStringList.Create;
                extract_key_values(l_raw_request_string, pv_c_key_value_list);

                write_log('Received:');
                write_log('  Rem >'+ m_remote_address_string+ '<');
                write_log('  raw >'+ l_raw_request_string+ '<');

                Free;
              end; // with c_form.create_form
        end; // analyze_form_values

      procedure evaluate_request(p_c_key_value_list: tStringList;
          p_c_html_base_page_builder: c_html_base_page_builder);
        var l_key, l_next, l_forward, l_backward: String;
            l_c_table: tTable;
            l_locate_result: Boolean;
            l_line_count: Integer;
            l_column: Integer;
            l_foward_direction: Boolean;
            l_the_cell: String;
        begin
          with p_c_key_value_list do
          begin
            l_key:= Values['key'];
            l_next:= Values['next'];
            l_forward:= Values['forward'];
            l_backward:= Values['backward'];

            l_foward_direction:= (l_forward= '>');
          end; // with p_c_key_value_list

          write_log(' kv ='+ p_c_key_value_list.Text+ '|');
          write_log(' resu ='+ l_key+ ' '+ l_next);

          // l_next= '2';
          with p_c_html_base_page_builder do
          begin
            build_page_start;

            build_line('    <H2><CENTER>Felix COLIBRI - Database Browser</CENTER></H2>');
            // -- add moving buttons

            // add_line('<INPUT TYPE=text NAME=q SIZE= '+ IntToStr(2+ 2* l_column)+ '>');

            l_c_table:= tTable.Create(Nil);
            with l_c_table do
            begin
              DatabaseName:= 'dbdemos';
              TableName:= 'Animals.dbf';
              IndexName:= 'Name';
              Open;

              if l_key<> ''
                then begin
                    l_locate_result:= Locate('Name', l_key, [loPartialKey]);
                    if l_locate_result
                      then begin
                          l_next:= '2';
                          build_line('key='+ l_key+ ', next='+ l_next);

                          if not l_foward_direction
                            then l_next:= '-'+ l_next;
                          build_line('MoveBy '+ l_next);
                          MoveBy(StrToInt(l_next));
                        end
                      else build_line('key='+ l_key+ ' not_found, next= '+ l_next);
                    write_log(f_display_TF(l_locate_result));
                end
              else build_line('no_key, next= '+ l_next);

              build_line(', first '+ Fields[0].AsString);

              // -- send back the first row's key
              build_line('    <FORM method="POST"');
              build_line('      ACTION="http://127.0.0.1/scripts/cgi_database_browser.exe">');
              build_line('      <INPUT TYPE="submit" NAME=backward VALUE="<">');
              build_line('      <INPUT TYPE="submit" NAME=forward VALUE=">">');
              build_line('      <INPUT TYPE=HIDDEN NAME="key" VALUE="'+ Fields[0].AsString+ '">');
              build_line('    </FORM>');

              build_line('    <TABLE border=1 cellspacing=0 cellpadding=1>');
              l_line_count:= 0;
              while not Eof and (l_line_count< 5) do
              begin
                 build_line('      <TR>');
                 for l_column:= 0 to 3 do // Table1.Fields.Count- 1 do
                 begin
                   if l_column in [1, 2]
                     then l_the_cell:= '        <TD align=right>'
                     else l_the_cell:= '        <TD>';
                   l_the_cell:= l_the_cell+ Fields[l_column].AsString+ '</TD>';
                   build_line(l_the_cell);
                 end;
                 build_line('      </TR>');

                write_log(FieldByName('Name').AsString);

                Next;
                Inc(l_line_count);
              end; // while not Eof
              build_line('    </TABLE>');

              Close;
              Free;
            end; // with l_c_table

            build_page_end;
          end;
        end; // evaluate_request

      procedure send_answer(p_output_name: String;
          p_c_html_base_page_builder: c_html_base_page_builder);
        var l_output: Text;

        procedure send_empty_answer;
          begin
            writeln(l_output, '<HTML>');
            writeln(l_output, '  <BODY>');
            writeln(l_output, '    No answser');
            writeln(l_output, '  </BODY>');
            writeln(l_output, '</HTML>');
          end; // send_empty_answer

        var l_length: Integer;
            l_line_index: Integer;

        begin // send_answer
          // -- now output the answer
          Assign(l_output, p_output_name);
          Rewrite(l_output);

          write_log('  => Answser: header_ok');

          with p_c_html_base_page_builder.m_c_html_page do
          begin
            l_length:= Length(Text);

            // writeln(l_output, 'HTTP/1.0 200 OK');
            // -- for the .HTML debug output, do not send the header
            if not f_is_debug or (ExtractFileExt(p_output_name)<> '.html')
              then begin
                  writeln(l_output, k_content_type);
                  if l_length<> 0
                    then writeln(l_output, 'Content-Length='+ IntToStr(Length(Text)));
                  writeln(l_output);
                end;

            if Count= 0
              then send_empty_answer
              else begin
                  for l_line_index:= 0 to Count- 1 do
                    write_log('  |'+  Strings[l_line_index]+ '|');

                  write(l_output, Text);
                end;
          end; // with p_c_html_base_page_builder

          Close(l_output);

          write_log('  ok_sent');
        end; // send_answer

      procedure test_answer_ok;
          // -- bogus trial
        var l_output: Text;
        begin
          // -- now build the answer
          Assign(l_output, g_output_name);
          Rewrite(l_output);

          // writeln(l_output, 'HTTP/1.0 200 OK');
          writeln(l_output, k_content_type);
          writeln(l_output);

          writeln(l_output, '<HTML>');
          writeln(l_output, '  <BODY>');
          writeln(l_output, '    log_ok ok');
          writeln(l_output, '  </BODY>');
          writeln(l_output, '</HTML>');

          Close(l_output);
        end; // test_answer_ok

      var l_c_key_value_list: tStringList;
          l_site_url: String;
          l_c_html_base_page_builder: c_html_base_page_builder;

      begin // do_handle_cgi
        Try
          open_log(f_cgi_exe_path+ p_write_segment+ p_log_name);
          // -- debug
          // log_enviroment;

          // -- get the request without % etc
          write_log('== analyze_form_values');
          l_c_key_value_list:= tStringList.Create;

          analyze_form_values(l_c_key_value_list);

          write_log('== load_cgi_text');

          if f_is_debug
            then l_site_url:= ''
            else l_site_url:= p_site_url;

          l_c_html_base_page_builder:=
              c_html_base_page_builder.create_html_base_page_builder('request',
              l_site_url);

          // -- build the target file list
          evaluate_request(l_c_key_value_list, l_c_html_base_page_builder);

          write_log('== send_answer');
          // test_answer_ok
          send_answer(g_output_name, l_c_html_base_page_builder);
          // -- in debug mode, also output an .html version of the answer on the local disc
          if f_is_debug
            then send_answer(ChangeFileExt(g_output_name, '.html'), l_c_html_base_page_builder);

          l_c_key_value_list.Free;
          l_c_html_base_page_builder.Free;

          write_log('== end ok');
        except
          write_log('*** exception');
        end;
      end; // do_handle_cgi

    end.

